/*	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



/*
  _      _ _                   _           
 | |    (_) |                 (_)          
 | |     _| |__  _ __ ___ _ __ _  __ _ ___ 
 | |    | | '_ \| '__/ _ \ '__| |/ _` / __|
 | |____| | |_) | | |  __/ |  | | (_| \__ \
 |______|_|_.__/|_|  \___|_|  |_|\__,_|___/

*/

#include <cpctelera.h>
#include "tiles.h"
#include "player.h"
#include "enemigo.h"
#include "bala.h"
#include "coke.h"
#include "mapas.h"
//#include "music/p1.h"
//#include "nodos.c"


/*
  _____        __ _       _      _                       
 |  __ \      / _(_)     (_)    (_)                      
 | |  | | ___| |_ _ _ __  _  ___ _  ___  _ __   ___  ___ 
 | |  | |/ _ \  _| | '_ \| |/ __| |/ _ \| '_ \ / _ \/ __|
 | |__| |  __/ | | | | | | | (__| | (_) | | | |  __/\__ \
 |_____/ \___|_| |_|_| |_|_|\___|_|\___/|_| |_|\___||___/
                                                      
*/


// General
#define NO                    0
#define SI                    1

// Colores
#define NEGRO                 0
#define BLANCO                15
#define ROJO                  0x30

// Player
#define PLAYER_W               G_PLAYER_00_W
#define PLAYER_H               G_PLAYER_00_H
#define IMG_JUG_DER_QUIETO     g_player_00
#define IMG_JUG_DER_ANDANDO_1  g_player_01
#define IMG_JUG_DER_ANDANDO_2  g_player_02
#define IMG_JUG_DER_ANDANDO_3  g_player_03
#define IMG_JUG_DER_SALTANDO   g_player_04
#define IMG_JUG_DER_CAYENDO    g_player_05
#define IMG_JUG_DER_DISPARANDO g_player_06
#define IMG_JUG_IZQ_QUIETO     g_player_07
#define IMG_JUG_IZQ_ANDANDO_1  g_player_08
#define IMG_JUG_IZQ_ANDANDO_2  g_player_09
#define IMG_JUG_IZQ_ANDANDO_3  g_player_10
#define IMG_JUG_IZQ_SALTANDO   g_player_11
#define IMG_JUG_IZQ_CAYENDO    g_player_12
#define IMG_JUG_IZQ_DISPARANDO g_player_13

// Enemigo
#define IMG_ENE_DER_QUIETO     g_enemigo_00
#define IMG_ENE_DER_ANDANDO_1  g_enemigo_01
#define IMG_ENE_DER_ANDANDO_2  g_enemigo_02
#define IMG_ENE_DER_ANDANDO_3  g_enemigo_03
#define IMG_ENE_DER_SALTANDO   g_enemigo_04
#define IMG_ENE_DER_CAYENDO    g_enemigo_05
#define IMG_ENE_DER_DISPARANDO g_enemigo_06
#define IMG_ENE_IZQ_QUIETO     g_enemigo_07
#define IMG_ENE_IZQ_ANDANDO_1  g_enemigo_08
#define IMG_ENE_IZQ_ANDANDO_2  g_enemigo_09
#define IMG_ENE_IZQ_ANDANDO_3  g_enemigo_10
#define IMG_ENE_IZQ_SALTANDO   g_enemigo_11
#define IMG_ENE_IZQ_CAYENDO    g_enemigo_12
#define IMG_ENE_IZQ_DISPARANDO g_enemigo_13

#define MAX_ENEMIGOS		   7//2


// Bala
#define ANCHO_BALA            G_BALA_W
#define ALTO_BALA             G_BALA_H
#define IMAGEN_BALA           g_bala
#define MAX_BALAS             20
#define MAX_RECORRIDO_BALA    50


// Pantalla
#define ANCHO_PANTALLA_PX     160
#define ALTO_PANTALLA_PX      200
#define NUM_MAPAS_ANCHO       8

#define ANCHO_PANTALLA_BYTE   ANCHO_PANTALLA_PX/2
#define ALTO_PANTALLA_BYTE    ALTO_PANTALLA_PX

#define ANCHO_PANTALLA_BLOQUE ANCHO_PANTALLA_PX/4
#define ALTO_PANTALLA_BLOQUE  ALTO_PANTALLA_PX/8

#define ORIGEN_MAPA_X         0
#define ORIGEN_MAPA_Y         0
#define ORIGEN_MAPA           cpctm_screenPtr(back_buffer, ORIGEN_MAPA_X, ORIGEN_MAPA_Y)

#define LIMITE_IZQUIERDO      ORIGEN_MAPA_X
#define LIMITE_ARRIBA         ORIGEN_MAPA_Y
#define LIMITE_DERECHO        ANCHO_PANTALLA_BYTE - PLAYER_W - 1 // -1 ¿?
#define LIMITE_ABAJO          ALTO_PANTALLA_BYTE  - PLAYER_H - 1 // -1 ¿?

/* Menu
#define ORIGEN_MENU_X         8
#define ORIGEN_MENU_Y         64
#define ORIGEN_MENU           cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_MENU_X, ORIGEN_MENU_Y)
#define ANCHO_MENU            64 //64 es el MAX dibujable
#define ALTO_MENU             80

#define ORIGEN_MENU2_X        9
#define ORIGEN_MENU2_Y        68
#define ORIGEN_MENU2          cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_MENU2_X, ORIGEN_MENU2_Y)
#define ANCHO_MENU2           62 //64 es el MAX dibujable
#define ALTO_MENU2            72 //56

#define ORIGEN_TEXTO_X        12
#define ORIGEN_TEXTO1_Y       76
#define ORIGEN_TEXTO2_Y       92
#define ORIGEN_TEXTO3_Y       108
#define ORIGEN_TEXTO4_Y       124
#define ORIGEN_TEXTO1         cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_TEXTO_X, ORIGEN_TEXTO1_Y)
#define ORIGEN_TEXTO2         cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_TEXTO_X, ORIGEN_TEXTO2_Y)
#define ORIGEN_TEXTO3         cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_TEXTO_X, ORIGEN_TEXTO3_Y)
#define ORIGEN_TEXTO4         cpctm_screenPtr(CPCT_VMEM_START, ORIGEN_TEXTO_X, ORIGEN_TEXTO4_Y)
*/

// Nodos
#define NUM_NODOS			  20
#define NUM_NODOS_SALTO		  1
#define MAX_NODOS_CERCANOS	  4
#define MARGEN_NODOS_Y		  20
#define MARGEN_NODOS_X		  5

// Decisiones IA
/*#define IA_SALTAR
#define IA_NSALTAR
#define IA_DERECHA
#define IA_IZQUIERDA
#define IA_DISPARAR
#define IA_NDISPARAR*/


/*
  _____        _            
 |  __ \      | |           
 | |  | | __ _| |_ ___  ___ 
 | |  | |/ _` | __/ _ \/ __|
 | |__| | (_| | || (_) \__ \
 |_____/ \__,_|\__\___/|___/

*/



//Debug

	u8 d11,d12,d21,d22,d31, d32, d41, d42, d43, d51, d52, d53;

//

enum { PLAYER, ENEMIGO, BALA } Rol;

enum { QUIETO, ANDANDO, SALTANDO, CAYENDO, DISPARANDO, MUERTO } Estado;

enum { IZQUIERDA, DERECHA, ARRIBA, ABAJO , NADA } Direccion;

enum { HUIR, PERSEGUIR, ATACAR, ESPERA} EstadoIA;

//enum { PARADO, LENTO , NORMAL, RAPIDO } Velocidad;



typedef struct
{
	u8 x,y;
	u8 mapa;
	u8 tabla[NUM_NODOS];
	u8 cercanos[MAX_NODOS_CERCANOS];
} Nodo;

typedef struct
{
	//Paramtetros de personalidad (valentia etc...)
	u8 nodoObjetivo;
	u8 nodoSiguiente;
	u8 maxCerca;
	u8 estado;				// [HUIR, PERSEGUIR, ATACAR]
	u8 entidadObjetivo;

	u8 d_direccion; 	  	// [Direccion]
	u8 d_salto;				// [SI,NO]
	u8 d_disparar;			// [SI,NO]
} IA;

// Estructura del sprite
typedef struct
{
	const u8* imagen; // Puntero variable que apunta a algo constante
	u8 rol;           // [PLAYER, ENEMIGO, BALA]
	//u8 x, y;          // Coordenadas "x", "y"
	//u8 px, py;        // Coordenadas "x", "y" ANTIGUAS (para borrar sprite)
	u8 x[3], y[3];
	u8 draw;
	u8 numMapa;       // Número de mapa
	const u8* mapa;
	u8 direccion;
	u8 ancho, alto;
	u8 anchoBloques;
	u8 altoBloques;
	u8 enAire;        // Tiempo en el aire
//	u8 mover;         // [NO, SI]
} Sprite;

// Estructura de la entidad
typedef struct
{
	u8 estado;      // [QUIETO, ANDANDO, SALTANDO, CAYENDO, MUERTO]
	u8 id;    // Número de balas del jugador/enemigo
	Sprite* bala;   // Sprite de la bala
	Sprite* sprite; // Sprite propio
	u8 nodo;
	IA* ia;
} Entidad;

// Estructura del mapa
typedef struct
{
	const u8* bits; // Puntero variable que apunta a algo constante
	u8  pintar;     // [NO, SI]
//	u8  numero;
} Mapa;


extern u8 *back_buffer;
extern u8 *screen_mem;


/*
   _____                _              _            
  / ____|              | |            | |           
 | |     ___  _ __  ___| |_ __ _ _ __ | |_ ___  ___ 
 | |    / _ \| '_ \/ __| __/ _` | '_ \| __/ _ \/ __|
 | |___| (_) | | | \__ \ || (_| | | | | ||  __/\__ \
  \_____\___/|_| |_|___/\__\__,_|_| |_|\__\___||___/

*/

// Tabla de transparencia
cpctm_createTransparentMaskTable(transparentMaskTable, 0x3F00, M0, 0);



/*
 __      __        _       _     _           
 \ \    / /       (_)     | |   | |          
  \ \  / /_ _ _ __ _  __ _| |__ | | ___  ___ 
   \ \/ / _` | '__| |/ _` | '_ \| |/ _ \/ __|
    \  / (_| | |  | | (_| | |_) | |  __/\__ \
     \/ \__,_|_|  |_|\__,_|_.__/|_|\___||___/

*/

//u8 menu;


// Mapa
Mapa   mapa;

// Nodos

//Nodo listaNodos[NUM_NODOS + NUM_NODOS_SALTO];
extern Nodo listaNodos[NUM_NODOS + NUM_NODOS_SALTO];


u8 contador;
u8 empiezaJuego;
u8 gameover;

/*
Sprite spriteJugador = {IMAGEN_QUIETO,  PLAYER, 37*2, 22*8, 37*2, 22*8, 0, DERECHA, PLAYER_W, PLAYER_H, 2, 3, NO, NO};
Sprite spriteEnemigo = {IMAGEN_ENEMIGO, ENEMIGO, 0, 0, 0, 0, 0, DERECHA, ANCHO_ENEMIGO, ALTO_ENEMIGO, 2, 3, NO, NO};
Sprite spriteBala    = {IMAGEN_BALA,    BALA,    0, 0, 0, 0, 0, DERECHA, ANCHO_BALA,    ALTO_BALA,    1, 1, NO, NO};

Entidad player =
	{DERECHA, QUIETO, 10, &spriteBala, &spriteJugador};

Entidad enemigo[MAX_ENEMIGOS] = {
	{DERECHA, QUIETO, 10, &spriteBala, &spriteEnemigo},
	{DERECHA, QUIETO, 10, &spriteBala, &spriteEnemigo}
};
*/

Sprite spriteJugador;
Sprite spriteEnemigo[MAX_ENEMIGOS];
Sprite spriteBala[MAX_ENEMIGOS+1];
IA iaenemigo[MAX_ENEMIGOS];

Entidad player;
Entidad enemigo[MAX_ENEMIGOS];
//Entidad enemigo1;

// Número de balas moviéndose
u8 totalBalas = 0;

// Entidad enemigoPlantilla = {8, 10, 10, 10, 10, DERECHA, PAUSA};
// Duplicar structs contantes
//cpct_memcpy((void*)¬g_hero, &template, sizeof(TEntity));


/*
  __  __                      _ _ _ _                     
 |  \/  |                    (_) | (_)                    
 | \  / |     __ _ _   ___  ___| | |_  __ _ _ __ ___  ___ 
 | |\/| |    / _` | | | \ \/ / | | | |/ _` | '__/ _ \/ __|
 | |  | |_  | (_| | |_| |>  <| | | | | (_| | | |  __/\__ \
 |_|  |_(_)  \__,_|\__,_/_/\_\_|_|_|_|\__,_|_|  \___||___/

*/

u8 abs(u8 a, u8 b)
{
	if (a < b) return b-a;
	else       return a-b;
}

u8 distancia(u8 x1, u8 y1, u8 x2, u8 y2){
	return abs(x1,x2)/2 + abs(y1,y2)/2;
}

u8 distanciaEN(Entidad* entidad, u8 nodo){
	u8 disx = abs(entidad->sprite->x[0],listaNodos[nodo].x);
	u8 disy = abs(entidad->sprite->y[0],listaNodos[nodo].y);
	if (abs(entidad->sprite->numMapa, listaNodos[nodo].mapa) > 0)
		return 250;
	return disx + disy;
}

/*void guardarNuevasCoor(Sprite* sprite) //__z88dk_fastcall
{
	sprite->px = sprite->x;
	sprite->py = sprite->y;
}*/


/*
  _____  _ _           _            
 |  __ \(_) |         (_)           
 | |  | |_| |__  _   _ _  __ _ _ __ 
 | |  | | | '_ \| | | | |/ _` | '__|
 | |__| | | |_) | |_| | | (_| | |   
 |_____/|_|_.__/ \__,_| |\__,_|_|   
                     _/ |           
                    |__/            

*/
/////////////// doble buffer

void dummy_inicializarDobleBuffer()
{
__asm
	_back_buffer::  .dw 0x8000
	_screen_mem::   .dw 0xC000
__endasm;
}

void dibujarCoke() //__z88dk_fastcall
{
	u8* pvmem = cpct_getScreenPtr(back_buffer, 64, 164);
	cpct_drawSpriteMaskedAlignedTable (g_coke, pvmem, G_COKE_W, G_COKE_H, transparentMaskTable);
}

// Necesita x, y, ancho, alto, *imagen
void dibujar(Sprite* sprite) //__z88dk_fastcall
{
	u8* pvmem = cpct_getScreenPtr(back_buffer, sprite->x[0], sprite->y[0]);
	cpct_drawSpriteMaskedAlignedTable (sprite->imagen, pvmem, sprite->ancho, sprite->alto, transparentMaskTable);
}

// Necesita x, y, anchoBloques, altoBloques
void borrar(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX       = sprite->x[2]/2;
	u8  bY       = sprite->y[2]/8;
	u8  bXMax    = bX + sprite->anchoBloques;
	u8  bYMax    = bY + sprite->altoBloques;
	u16 index    = ANCHO_PANTALLA_BLOQUE * bY + bX;
	u8  bXInicio = bX;

	while(bY<bYMax)
	{
		while(bX<bXMax)
		{
			if (cpct_getBit(mapa.bits, index))
				cpct_drawTileAligned2x8_f (g_tiles_1, cpct_getScreenPtr(back_buffer, bX*2, bY*8)); // Bloque
			else
				cpct_drawTileAligned2x8_f (g_tiles_0, cpct_getScreenPtr(back_buffer, bX*2, bY*8)); // Fondo
			
			index++;
			bX++;
		}
		bX = bXInicio;
		bY++;
		index = ANCHO_PANTALLA_BLOQUE * bY + bX;
	}
}

void actualizar(Sprite* sprite)
{
	u8* x = sprite->x + 2;
	u8* y = sprite->y + 2;
	*x = *(x-1); --x; *x = *(x-1);
	*y = *(y-1); --y; *y = *(y-1);
	--sprite->draw;
}

void intercambiarBuffers()
{
	u8* aux   = back_buffer;
	back_buffer = screen_mem;
	screen_mem = aux;

	// Set video memory page
	cpct_setVideoMemoryPage( ((u16)screen_mem)>>10 );
}

void redibujar(Sprite* sprite) //__z88dk_fastcall
{
	if (sprite->numMapa == player.sprite->numMapa && sprite->draw)
	{
		borrar(sprite);
		dibujar(sprite);
		actualizar(sprite);
	}
}


/*void dibujarMenu()
{
	cpct_drawSolidBox (ORIGEN_MENU,  ROJO,  ANCHO_MENU,  ALTO_MENU);
	cpct_drawSolidBox (ORIGEN_MENU2, NEGRO, ANCHO_MENU2, ALTO_MENU2);

//	cpct_drawStringM0 (void* string, void* video_memory, u8 fg_pen, u8 bg_pen)
	cpct_drawStringM0("PLAY-PAUSE (P)", ORIGEN_TEXTO1, BLANCO, NEGRO);
	cpct_drawStringM0("KEY CONTR  (K)", ORIGEN_TEXTO2, BLANCO, NEGRO);
	cpct_drawStringM0("CREDITS    (C)", ORIGEN_TEXTO3, BLANCO, NEGRO);
	cpct_drawStringM0("EXIT       (E)", ORIGEN_TEXTO4, BLANCO, NEGRO);
}*/

void dibujarControles()
{//                    --------------------||||||||||||||||||||--------------------||||||||||||||||||||-------------__-__-__--||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||
	cpct_drawStringM0("                                              CONTROLS                            Movement   \b \t \v                        Shooting   SPACE                      ", ORIGEN_MAPA, BLANCO, NEGRO);
}

void dibujarCreditos()
{//                    --------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||
	cpct_drawStringM0("                                             DEVELOPERS                          F. Javier Abellan                      Antonio Villaescusa                                                MENTOR                            Francisco Gallego                      ", ORIGEN_MAPA, BLANCO, NEGRO);
}

void dibujarFinal()
{//                    --------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||--------------------||||||||||||||||||||
	cpct_drawStringM0("                                         Good night, Elliot                                         ", ORIGEN_MAPA, BLANCO, NEGRO);
}

void dibujarMapa() //__z88dk_fastcall
{
	u8 bX=0, bY=0;
	u16 index=0;
	u8 i = 0;

//	switch(player.sprite->numMapa)
//	{
//		case 0:  mapa.bits = casa;     break;
//		case 1:  mapa.bits = portada;  break;
//		case 2:  mapa.bits = creditos; break;
//		case 8:  mapa.bits = map11;    break;
//		case 9:  mapa.bits = map21;    break;
//		case 10: mapa.bits = map31;    break;
//		case 16: mapa.bits = map12;    break;
//		case 17: mapa.bits = map22;    break;
//		case 18: mapa.bits = map32;    break;
//		default: mapa.bits = creditos; // es casi igual que vacio
//	}

	mapa.bits = player.sprite->mapa;

	while(bY<ALTO_PANTALLA_BLOQUE)
	{
		while(bX<ANCHO_PANTALLA_BLOQUE)
		{
			if (cpct_getBit(mapa.bits, index))
				cpct_drawTileAligned2x8_f (g_tiles_1, cpct_getScreenPtr(back_buffer, bX*2, bY*8)); // Bloque
			else
				cpct_drawTileAligned2x8_f (g_tiles_0, cpct_getScreenPtr(back_buffer, bX*2, bY*8)); // Fondo
			index++;
			bX++;
		}
		bX=0;
		bY++;
	}

	if (player.sprite->numMapa==16)     dibujarControles();
	if (player.sprite->numMapa==99)    {dibujarFinal(); dibujarCoke();}
	if (mapa.bits==creditos) dibujarCreditos();

	// Pintar enemigos quietos en ese mapa
	for (i=0; i<MAX_ENEMIGOS; i++)
	{
		if (player.sprite->numMapa == enemigo[i].sprite->numMapa && enemigo[i].estado==QUIETO)
			dibujar(enemigo[i].sprite);
	}

	--mapa.pintar; //mapa.pintar = NO;
}

//////////////////// ANTES
/*
// Necesita x, y, ancho, alto, *imagen
void dibujar(Sprite* sprite) //__z88dk_fastcall
{
	u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, sprite->x, sprite->y);
	cpct_drawSpriteMaskedAlignedTable (sprite->imagen, pvmem, sprite->ancho, sprite->alto, transparentMaskTable);
}

// Necesita x, y, anchoBloques, altoBloques
void borrar(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX       = sprite->px/2;
	u8  bY       = sprite->py/8;
	u8  bXMax    = bX + sprite->anchoBloques;
	u8  bYMax    = bY + sprite->altoBloques;
	u16 index    = ANCHO_PANTALLA_BLOQUE * bY + bX;
	u8  bXInicio = bX;

	while(bY<bYMax)
	{
		while(bX<bXMax)
		{
			if (cpct_getBit(mapa.bits, index))
				cpct_drawTileAligned2x8_f (g_tiles_1, cpct_getScreenPtr(CPCT_VMEM_START, bX*2, bY*8)); // Bloque
			else
				cpct_drawTileAligned2x8_f (g_tiles_0, cpct_getScreenPtr(CPCT_VMEM_START, bX*2, bY*8)); // Fondo
			
			index++;
			bX++;
		}
		bX = bXInicio;
		bY++;
		index = ANCHO_PANTALLA_BLOQUE * bY + bX;
	}
}

void redibujar(Sprite* sprite) //__z88dk_fastcall
{
	if (sprite->numMapa == player.sprite->numMapa)
	{
		borrar(sprite);
		dibujar(sprite);
	}
	guardarNuevasCoor(sprite);
}*/

/*void direccionarSprite(Entidad* entidad) //__z88dk_fastcall
{
	// Seleccionar dirección correcta
	if (entidad->direccion != entidad->sprite->direccion)
	{
		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, IMAGEN_DER_QUIETO);
		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, IMAGEN_DER_ANDANDO_1);
		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, IMAGEN_DER_SALTANDO);
		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, IMAGEN_DER_CAYENDO);
		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, IMAGEN_DER_DISPARANDO);
		entidad->sprite->direccion = entidad->direccion;
	}

//	if (player.direccion != player.sprite->direccion)
//	{
//		cpct_hflipSpriteM0 (PLAYER_W, PLAYER_H, player.sprite->imagen);
//		player.sprite->direccion = player.direccion;
//	}
}*/


/*
   _____      _ _     _                       
  / ____|    | (_)   (_)                      
 | |     ___ | |_ ___ _  ___  _ __   ___  ___ 
 | |    / _ \| | / __| |/ _ \| '_ \ / _ \/ __|
 | |___| (_) | | \__ \ | (_) | | | |  __/\__ \
  \_____\___/|_|_|___/_|\___/|_| |_|\___||___/

*/

/*u8 colisionan(u8 ax,u8 ay,u8 aw,u8 ah,u8 bx,u8 by,u8 bw,u8 bh){
	return (ax < bx + bw &&
			ax + aw > bx &&
			ay < by + bh &&
			ay + ah > by);
}*/
u8 colision(Sprite* sprite1, Sprite* sprite2)
{
	return (sprite1->numMapa == sprite2->numMapa &&
			sprite1->x[0] + sprite1->ancho > sprite2->x[0]   &&
			sprite2->x[0] + sprite2->ancho > sprite1->x[0]   &&
			sprite1->y[0] + sprite1->alto  > sprite2->y[0]   &&
			sprite2->y[0] + sprite2->alto  > sprite1->y[0]);
}

u8 colisionIzquierda(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX       = (sprite->x[0]-1)/2; // Coordenada x del bloque
	u8  bY1      = sprite->y[0]/8;     // Coordenada y del bloque de arriba
	u8  bY2      = bY1+1;            // Coordenada y del bloque de enmedio
//	u8  bY3      = bY2+1;            // Coordenada y del bloque de abajo
	u16 index1   = ANCHO_PANTALLA_BLOQUE * bY1 + bX;
	u16 index2   = ANCHO_PANTALLA_BLOQUE * bY2 + bX;
	//u16 index3   = ANCHO_PANTALLA_BLOQUE * bY3 + bX;

	return cpct_getBit(sprite->mapa, index1) || cpct_getBit(sprite->mapa, index2);
}

u8 colisionDerecha(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX       = (sprite->x[0] + sprite->ancho)/2; // Coordenada x del bloque
	u8  bY1      = sprite->y[0]/8;              // Coordenada y del bloque de arriba
	u8  bY2      = bY1+1;                     // Coordenada y del bloque de enmedio
//	u8  bY3      = bY2+1;                     // Coordenada y del bloque de abajo
	u16 index1   = ANCHO_PANTALLA_BLOQUE * bY1 + bX;
	u16 index2   = ANCHO_PANTALLA_BLOQUE * bY2 + bX;
	//u16 index3   = ANCHO_PANTALLA_BLOQUE * bY3 + bX;

	return cpct_getBit(sprite->mapa, index1) || cpct_getBit(sprite->mapa, index2);
}

u8 colisionArriba(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX1      = sprite->x[0]/2;      // Coordenada x del bloque izquierdo
	u8  bX2      = bX1+1;            // Coordenada x del bloque derecho
	u8  bY       = (sprite->y[0]-1)/8;  // Coordenada y del bloque
	u16 index1   = ANCHO_PANTALLA_BLOQUE * bY + bX1;
	u16 index2   = ANCHO_PANTALLA_BLOQUE * bY + bX2;

	return cpct_getBit(sprite->mapa, index1) || cpct_getBit(sprite->mapa, index2);
}

u8 colisionAbajo(Sprite* sprite) //__z88dk_fastcall
{
	u8  bX1      = sprite->x[0]/2;            // Coordenada x del bloque izquierdo
	u8  bX2      = bX1+1;                   // Coordenada x del bloque derecho
	u8  bY       = (sprite->y[0]+sprite->alto)/8; // Coordenada y del bloque de abajo
	u16 index1   = ANCHO_PANTALLA_BLOQUE * bY + bX1;
	u16 index2   = ANCHO_PANTALLA_BLOQUE * bY + bX2;

	return cpct_getBit(sprite->mapa, index1) || cpct_getBit(sprite->mapa, index2);
}

void ajustarAlSuelo(Sprite* sprite) //__z88dk_fastcall
{
	sprite->y[0] = sprite->y[0] & 0b11111000; // Porque los bloques son 8 de alto
}


/*
  __  __            _           _            _        
 |  \/  |          (_)         (_)          | |       
 | \  / | _____   ___ _ __ ___  _  ___ _ __ | |_ ___  
 | |\/| |/ _ \ \ / / | '_ ` _ \| |/ _ \ '_ \| __/ _ \ 
 | |  | | (_) \ V /| | | | | | | |  __/ | | | || (_) |
 |_|  |_|\___/ \_/ |_|_| |_| |_|_|\___|_| |_|\__\___/ 

*/

void cambiarMapa(Sprite* sprite, u8 direccion)
{
	borrar(sprite);intercambiarBuffers();borrar(sprite);intercambiarBuffers(); // Esto es un apaño

	// Elegir nuevo mapa
	switch(direccion)
	{
		case IZQUIERDA: sprite->numMapa--;  break;
		case DERECHA:   sprite->numMapa++;  break;
		case ARRIBA:    sprite->numMapa-=NUM_MAPAS_ANCHO; break; // - 8
		case ABAJO:     sprite->numMapa+=NUM_MAPAS_ANCHO; break; // + 8
	}



/*	switch(sprite->numMapa)
	{
		case 0:  sprite->mapa = casa;     break;
		case 1:  sprite->mapa = portada;  break;
		case 2:  sprite->mapa = creditos; break;
		case 8:  sprite->mapa = map11;    break;
		case 9:  sprite->mapa = map21;    break;
		case 10: sprite->mapa = map31;    break;
		case 16: sprite->mapa = map12;    break;
		case 17: sprite->mapa = map22;    break;
		case 18: sprite->mapa = map32;    break;
		default: sprite->mapa = creditos; // es casi igual que vacio
	}*/

	if (sprite->numMapa==25){
		sprite->numMapa=1;
		empiezaJuego = SI;
	}
	switch(sprite->numMapa)
	{
		case 16: sprite->mapa = casa;     break;
		case 17: sprite->mapa = portada;  break;
		case 18: sprite->mapa = creditos; break;
		case 0:  sprite->mapa = map11;    break;
		case 1:  sprite->mapa = map21;    break;
		case 2:  sprite->mapa = map31;    break;
		case 8:  sprite->mapa = map12;    break;
		case 9:  sprite->mapa = map22;    break;
		case 10: sprite->mapa = map32;    break;
		case 99: sprite->mapa = casa;     break;
		default: sprite->mapa = creditos; // es casi igual que vacio
	}

	// Recolocar entidad
	switch(direccion)
	{
		case IZQUIERDA: sprite->x[0] = LIMITE_DERECHO;   break;
		case DERECHA:   sprite->x[0] = LIMITE_IZQUIERDO; break;
		case ARRIBA:    sprite->y[0] = LIMITE_ABAJO;     break;
		case ABAJO:     sprite->y[0] = LIMITE_ARRIBA;    break;
	}

	// Pintar mapa solo cuando sea el player
	if (sprite->rol==PLAYER) mapa.pintar = 2; //mapa.pintar = SI;
}


void moverIzquierda(Sprite* sprite, u8 desplazamiento)
{
	if (!colisionIzquierda(sprite) && desplazamiento)
	{
		if (sprite->x[0] == LIMITE_IZQUIERDO) cambiarMapa(sprite, IZQUIERDA);
		else sprite->x[0]--;

		moverIzquierda(sprite, desplazamiento-1);
	}
}


void moverDerecha(Sprite* sprite, u8 desplazamiento)
{
	if (!colisionDerecha(sprite) && desplazamiento)
	{
		if (sprite->x[0] == LIMITE_DERECHO) cambiarMapa(sprite, DERECHA);
		else sprite->x[0]++;

		moverDerecha(sprite, desplazamiento-1);
	}
}

void moverArriba(Sprite* sprite, u8 desplazamiento)
{
	if (!colisionArriba(sprite) && desplazamiento)
	{
		if (sprite->y[0] == LIMITE_ARRIBA) cambiarMapa(sprite, ARRIBA);
		else sprite->y[0]--;

		moverArriba(sprite, desplazamiento-1);
	}
}

void moverAbajo(Sprite* sprite, u8 desplazamiento)
{
	if (!colisionAbajo(sprite) && desplazamiento)
	{
		if (sprite->y[0] == LIMITE_ABAJO) cambiarMapa(sprite, ABAJO);
		else sprite->y[0]++;

		moverAbajo(sprite, desplazamiento-1);
	}
}

void mover(Sprite* sprite, u8 direccion, u8 desplazamiento)
{
	//cpct_setBorder(HW_BRIGHT_WHITE);
	switch(direccion)
	{
		case IZQUIERDA: moverIzquierda(sprite, desplazamiento); break;
		case DERECHA:   moverDerecha(sprite, desplazamiento);   break;
		case ARRIBA:    moverArriba(sprite, desplazamiento);    break;
		case ABAJO:     moverAbajo(sprite, desplazamiento);     break;
	}
	sprite->draw = 2;
	//cpct_setBorder(HW_BLACK);
}


/*
  _____       _      _                        _            _           
 |_   _|     (_)    (_)                      | |          | |          
   | |  _ __  _  ___ _  __ _ _ __    ___  ___| |_ __ _  __| | ___  ___ 
   | | | '_ \| |/ __| |/ _` | '__|  / _ \/ __| __/ _` |/ _` |/ _ \/ __|
  _| |_| | | | | (__| | (_| | |    |  __/\__ \ || (_| | (_| | (_) \__ \
 |_____|_| |_|_|\___|_|\__,_|_|     \___||___/\__\__,_|\__,_|\___/|___/

*/

// Mira el rol, estado, y direccion
void asignarImagen(Entidad* entidad)
{
	if (entidad->sprite->rol == PLAYER)
	{
		switch(entidad->estado)
		{
			case QUIETO:     entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_JUG_IZQ_QUIETO     : IMG_JUG_DER_QUIETO;     break;
			case ANDANDO:    entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_JUG_IZQ_ANDANDO_1  : IMG_JUG_DER_ANDANDO_1;  break;
			case SALTANDO:   entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_JUG_IZQ_SALTANDO   : IMG_JUG_DER_SALTANDO;   break;
			case CAYENDO:    entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_JUG_IZQ_CAYENDO    : IMG_JUG_DER_CAYENDO;    break;
			case DISPARANDO: entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_JUG_IZQ_DISPARANDO : IMG_JUG_DER_DISPARANDO; break;
		}
	}
	else
	{
		switch(entidad->estado)
		{
			case QUIETO:     entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_ENE_IZQ_QUIETO     : IMG_ENE_DER_QUIETO;     break;
			case ANDANDO:    entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_ENE_IZQ_ANDANDO_1  : IMG_ENE_DER_ANDANDO_1;  break;
			case SALTANDO:   entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_ENE_IZQ_SALTANDO   : IMG_ENE_DER_SALTANDO;   break;
			case CAYENDO:    entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_ENE_IZQ_CAYENDO    : IMG_ENE_DER_CAYENDO;    break;
			case DISPARANDO: entidad->sprite->imagen = (entidad->sprite->direccion==IZQUIERDA)? IMG_ENE_IZQ_DISPARANDO : IMG_ENE_DER_DISPARANDO; break;
		}
	}
}
void iniciaQuieto(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado          = QUIETO;
	entidad->sprite->draw    = 2;
	//entidad->sprite->mover   = NO;
	asignarImagen(entidad); //entidad->sprite->imagen  = (entidad->sprite->direccion==DERECHA)? IMAGEN_DER_QUIETO : IMAGEN_IZQ_QUIETO;

	////redibujar(entidad->sprite);
}

void iniciaReset(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado          = QUIETO;
	entidad->id        = MAX_BALAS;
	entidad->sprite->x[0]    = 37*2;
	entidad->sprite->y[0]    = 22*8;
//	entidad->sprite->mover   = SI;
	entidad->sprite->numMapa = 0;
	asignarImagen(entidad); //entidad->sprite->imagen  = IMAGEN_DER_QUIETO;

	dibujarMapa();
}

void iniciaAndar(Entidad* entidad, u8 direccion)
{
	entidad->estado            = ANDANDO;
	entidad->sprite->direccion = direccion;
//	entidad->sprite->mover     = SI;
	asignarImagen(entidad); //entidad->sprite->imagen    = (direccion==DERECHA)? IMAGEN_DER_ANDANDO_1 : IMAGEN_IZQ_ANDANDO_1;
}

void iniciaSaltar(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado         = SALTANDO;
	entidad->sprite->enAire = NO;
//	entidad->sprite->mover  = SI;
	asignarImagen(entidad); //entidad->sprite->imagen = (entidad->sprite->direccion==DERECHA)? IMAGEN_DER_SALTANDO : IMAGEN_IZQ_SALTANDO;
}

void iniciaCaer(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado         = CAYENDO;
	entidad->sprite->enAire = NO;
//	entidad->sprite->mover  = SI;
	asignarImagen(entidad); //entidad->sprite->imagen = (entidad->sprite->direccion==DERECHA)? IMAGEN_DER_CAYENDO : IMAGEN_IZQ_CAYENDO;
}

void iniciaDisparar(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado         = DISPARANDO;
//	entidad->sprite->mover  = NO; //TODO: PROVISIONAL
	asignarImagen(entidad); //entidad->sprite->imagen = (entidad->sprite->direccion==DERECHA)? IMAGEN_DER_DISPARANDO : IMAGEN_IZQ_DISPARANDO;
	entidad->bala->numMapa  = player.sprite->numMapa;
	entidad->bala->mapa     = player.sprite->mapa;
	entidad->sprite->draw   = 2;

	//redibujar(entidad->sprite);
}

void iniciaMorir(Entidad* entidad) //__z88dk_fastcall
{
	entidad->estado          = MUERTO;
//	entidad->sprite->mover   = NO;
//	entidad->sprite->imagen = IMAGEN_MUERTO;
//	iniciaReset(entidad);
}

void direccionar(Entidad* entidad, u8 direccion)
{
	if (entidad->sprite->direccion != direccion)
	{
		entidad->sprite->direccion = direccion;
		asignarImagen(entidad);
	}
}


/*
  _____                           _            _           _     _                       
 |_   _|__  _ __ ___   __ _    __| | ___    __| | ___  ___(_)___(_) ___  _ __   ___  ___ 
   | |/ _ \| '_ ` _ \ / _` |  / _` |/ _ \  / _` |/ _ \/ __| / __| |/ _ \| '_ \ / _ \/ __|
   | | (_) | | | | | | (_| | | (_| |  __/ | (_| |  __/ (__| \__ \ | (_) | | | |  __/\__ \
   |_|\___/|_| |_| |_|\__,_|  \__,_|\___|  \__,_|\___|\___|_|___/_|\___/|_| |_|\___||___/

*/

void decidirEnQuieto(Entidad* entidad)
{
	switch(entidad->sprite->rol)
	{
	case PLAYER:
		cpct_scanKeyboard_if();	
		if      (cpct_isKeyPressed(Key_Space))       iniciaDisparar(entidad);
		else if (cpct_isKeyPressed(Key_CursorUp))    iniciaSaltar(entidad);
		else if (cpct_isKeyPressed(Key_CursorLeft))  iniciaAndar(entidad, IZQUIERDA);
		else if (cpct_isKeyPressed(Key_CursorRight)) iniciaAndar(entidad, DERECHA);
		//else if (cpct_isKeyPressed(Key_R))           iniciaReset(entidad);
		// else: ya estoy en quieto
		break;
	case ENEMIGO:
		/*if (abs(entidad->sprite->x, player.sprite->x) > 20)
		{
			if (player.sprite->x < entidad->sprite->x)      iniciaAndar(entidad, IZQUIERDA);
			else if (player.sprite->x > entidad->sprite->x) iniciaAndar(entidad, DERECHA);
		}*/
		if (entidad->ia->d_disparar) iniciaDisparar(entidad);
		else if (entidad->ia->d_salto) iniciaSaltar(entidad);
		else if (entidad->ia->d_direccion == IZQUIERDA) iniciaAndar(entidad, IZQUIERDA);
		else if (entidad->ia->d_direccion == DERECHA) iniciaAndar(entidad, DERECHA);
		break;
	}
}

void decidirEnAndar(Entidad* entidad)
{
	switch(entidad->sprite->rol)
	{
	case PLAYER:
		cpct_scanKeyboard_if();
		if      (cpct_isKeyPressed(Key_CursorUp))    iniciaSaltar(entidad);
		else if (cpct_isKeyPressed(Key_CursorLeft))  direccionar(entidad, IZQUIERDA);
		else if (cpct_isKeyPressed(Key_CursorRight)) direccionar(entidad, DERECHA);
		else                                         iniciaQuieto(entidad);
		break;
	case ENEMIGO:
		/*if (abs(entidad->sprite->x, player.sprite->x) > 20)
		{
			if (player.sprite->x < entidad->sprite->x)      entidad->sprite->direccion=IZQUIERDA;
			else if (player.sprite->x > entidad->sprite->x) entidad->sprite->direccion=DERECHA;
		}
		else iniciaQuieto(entidad);*/
		if (entidad->ia->d_disparar) iniciaDisparar(entidad);
		else if (entidad->ia->d_salto) iniciaSaltar(entidad);
		else if (entidad->ia->d_direccion == IZQUIERDA) direccionar(entidad, IZQUIERDA);
		else if (entidad->ia->d_direccion == DERECHA) direccionar(entidad, DERECHA);
		else iniciaQuieto(entidad);
		break;
	}
}

void decidirEnSaltarCaer(Entidad* entidad)
{
	switch(entidad->sprite->rol)
	{
	case PLAYER:
		//Movimientos horizontales
		cpct_scanKeyboard_if();
		if (cpct_isKeyPressed(Key_CursorLeft))
		{
			mover(entidad->sprite, IZQUIERDA, 1);
			direccionar(entidad, IZQUIERDA);
		}
		else if (cpct_isKeyPressed(Key_CursorRight))
		{
			mover(entidad->sprite, DERECHA, 1);
			direccionar(entidad, DERECHA);
		}
		break;

	case ENEMIGO:
		if (entidad->ia->d_disparar) iniciaDisparar(entidad);
		//else if (entidad->ia->d_salto) iniciaSaltar(entidad);
		if (entidad->ia->d_direccion == IZQUIERDA){
			direccionar(entidad, IZQUIERDA);
			mover(entidad->sprite, IZQUIERDA, 1);
		}
		else if (entidad->ia->d_direccion == DERECHA){
			direccionar(entidad, DERECHA);
			mover(entidad->sprite, DERECHA, 1);
		}
		break;
	}
}

/*void leerMenu()
{
	u8 leer = SI;
	
	while(leer)
	{
		cpct_scanKeyboard_if();	
		if      (cpct_isKeyPressed(Key_P)) {leer=NO; menu=NO; }
		else if (cpct_isKeyPressed(Key_K)) {leer=NO; }//tutorial(); }
		else if (cpct_isKeyPressed(Key_C)) {leer=NO; }//creditos(); }
		else if (cpct_isKeyPressed(Key_E)) {leer=NO; }//salir();    }
	}
}*/

/*
  ______     _            _           
 |  ____|   | |          | |          
 | |__   ___| |_ __ _  __| | ___  ___ 
 |  __| / __| __/ _` |/ _` |/ _ \/ __|
 | |____\__ \ || (_| | (_| | (_) \__ \
 |______|___/\__\__,_|\__,_|\___/|___/

*/

void disparar(Entidad* entidad) //__z88dk_fastcall
{
	if (!entidad->bala->draw)// && entidad->numBalas > 0) //&& totalBalas < MAX_BALAS)
	{
		if (entidad->sprite->direccion==IZQUIERDA) entidad->bala->x[0] = entidad->sprite->x[0] - ANCHO_BALA;
		else                               entidad->bala->x[0] = entidad->sprite->x[0] + PLAYER_W;
		entidad->bala->y[0]      = entidad->sprite->y[0]+6;
		entidad->bala->x[1]      = entidad->sprite->x[1];
		entidad->bala->y[1]      = entidad->sprite->y[1];
		entidad->bala->direccion = entidad->sprite->direccion;
		entidad->bala->enAire    = 0;
		entidad->bala->draw      = 2;
		//entidad->bala->mover     = SI;
		//entidad->numBalas--;
		//totalBalas++;
	}

	// 2. Buscar siguiente estado: Leer teclado
	cpct_scanKeyboard_if();	
	if (!cpct_isKeyPressed(Key_Space)) iniciaQuieto(entidad);
}

void saltar(Entidad* entidad) //__z88dk_fastcall
{
	// 1. Ejecutar estado
	entidad->sprite->enAire++;

	// Movimientos verticales
	if      (entidad->sprite->enAire < 7)   mover(entidad->sprite, ARRIBA, 5); // Subir 3 pixels (en lo bajo)
	else if (entidad->sprite->enAire < 12)  mover(entidad->sprite, ARRIBA, 3); // Subir 2 pixels
	else if (entidad->sprite->enAire < 16)  mover(entidad->sprite, ARRIBA, 1); // Subir 1 pixel  (en lo alto)
	else                                    iniciaCaer(entidad);

	decidirEnSaltarCaer(entidad);

	// 2. Buscar siguiente estado: Si dejo de pulsar arriba, dejo de saltar
	//cpct_scanKeyboard_if();	
	//if (!cpct_isKeyPressed(Key_CursorUp)) iniciaCaer(entidad);
}


void caer(Entidad* entidad) //__z88dk_fastcall
{
	// 1. Ejecutar estado
	entidad->sprite->enAire++;

	if (!colisionAbajo(entidad->sprite))
	{
		// Movimientos verticales
		if      (entidad->sprite->enAire < 5)   mover(entidad->sprite, ABAJO, 1); // Caer 1 pixel  (en lo alto)
		else if (entidad->sprite->enAire < 12)  mover(entidad->sprite, ABAJO, 2); // Caer 2 pixels
		else                                    mover(entidad->sprite, ABAJO, 3); // Caer 3 pixels (en lo bajo)

		decidirEnSaltarCaer(entidad);
	}

	// 2. Buscar siguiente estado: Si me topo con el suelo
	else { ajustarAlSuelo(entidad->sprite); iniciaQuieto(entidad); }
}


void andar(Entidad* entidad) //__z88dk_fastcall
{
	// 1. Ejecutar estado
	mover(entidad->sprite, entidad->sprite->direccion, 1);

	// 2. Buscar siguiente estado: Leer teclado
	if (!colisionAbajo(entidad->sprite))
		iniciaCaer(entidad);
	else
		decidirEnAndar(entidad);
}


void quieto(Entidad* entidad) //__z88dk_fastcall
{
	// 1. Ejecutar estado (nada que ejecutar)

	// 2. Buscar siguiente estado: Leer teclado
	decidirEnQuieto(entidad);
}


////////////////////////////////////////////////////////////// Función principal de estado
//
//  Aquí, según el estado que se tenga, se ejecuta.
//

void ejecutarEstado(Entidad* entidad) //__z88dk_fastcall
{
	u8 i;

	switch(entidad->estado)
	{
		case QUIETO:     quieto(entidad);      break;
		case ANDANDO:    andar(entidad);       break;
		case SALTANDO:   saltar(entidad);      break;
		case CAYENDO:    caer(entidad);        break;
		case DISPARANDO: disparar(entidad);    break;
		case MUERTO:                           break;
	}

	if (entidad->bala->draw) // Mover bala
	{
		entidad->bala->enAire++;

		if (entidad->bala->enAire!=MAX_RECORRIDO_BALA)
		{
			mover(entidad->bala, entidad->bala->direccion, 1);
			// Colision bala
			switch(entidad->sprite->rol)
			{
			case PLAYER:
				for (i=0; i<MAX_ENEMIGOS; i++)
					if (enemigo[i].estado!=MUERTO && colision(entidad->bala, enemigo[i].sprite))
					{
						iniciaMorir(&enemigo[i]);
						entidad->bala->draw = 0;
						borrar(entidad->bala);
						borrar(enemigo[i].sprite);
						intercambiarBuffers();
						borrar(entidad->bala);
						borrar(enemigo[i].sprite);
						intercambiarBuffers();
						++gameover;
					}
				break;
			case ENEMIGO:
				if (colision(entidad->bala, player.sprite))
				{
					iniciaMorir(&player);
					entidad->bala->draw = 0;
					borrar(entidad->bala);
					borrar(player.sprite);
					intercambiarBuffers();
					borrar(entidad->bala);
					borrar(player.sprite);
					intercambiarBuffers();
					gameover=MAX_ENEMIGOS;
				}
				else{
					for (i=0; i<MAX_ENEMIGOS; i++)
					if (enemigo[i].estado!=MUERTO && colision(entidad->bala, enemigo[i].sprite))
					{
						iniciaMorir(&enemigo[i]);
						entidad->bala->draw = 0;
						borrar(entidad->bala);
						borrar(enemigo[i].sprite);
						intercambiarBuffers();
						borrar(entidad->bala);
						borrar(enemigo[i].sprite);
						intercambiarBuffers();
					}
				}
			}
		}
		else
		{
			entidad->bala->draw = 0;
			borrar(entidad->bala);
			borrar(entidad->bala);
			intercambiarBuffers();
		}
	}
}

void debug_dummy(){
	u8 caca = 0;
	caca++;
}

u8 numEntidadesMapa(u8 n){
	u8 i = 0, sol = 0;
	if (player.sprite->numMapa == n) ++sol;
	while (i < MAX_ENEMIGOS){
		if (enemigo[i].sprite->numMapa == n) ++sol;
		++i;
	}
	return sol;
}

u8 numEntidadCerca(Entidad* entidad){
	u8 i=0;
	u8 mimapa = entidad->sprite->numMapa;
	u8 dist;
	u8 distaux;
	u8 sol;
	if (player.sprite->numMapa == mimapa){
		dist = distancia(entidad->sprite->x[0],entidad->sprite->y[0],player.sprite->x[0],player.sprite->y[0]);
		sol = 8;
	}
	while (i < MAX_ENEMIGOS){
		if (enemigo[i].id != entidad->id){
			if (distaux = distancia(entidad->sprite->x[0],entidad->sprite->y[0],enemigo[i].sprite->x[0],enemigo[i].sprite->y[0]) < dist){
				sol = i;
			}
		}
		++i;
	}
	return sol;
}


//IA

void CalcularIA(Entidad* entidad){
	//Calcular nodo actual
	u8 i = 0;
	u8 distaux = 0;
	u8 misiguiente;
	u8 miobjetivo;
	u8 mientidadobjetivo;
	u8 minodo = entidad->nodo;
	u8 mimapa;
	u8 miestado;
	if (entidad->estado != CAYENDO){
		while (i < MAX_NODOS_CERCANOS){
			distaux = distanciaEN(entidad,listaNodos[minodo].cercanos[i]);
			if (distaux < 2){
				if (listaNodos[minodo].cercanos[i] < 30) minodo = listaNodos[minodo].cercanos[i];
			}
			++i;
		}
	}
	entidad->nodo = minodo;
	entidad->ia->d_salto = NO;
	entidad->ia->d_direccion = NADA;
	entidad->ia->d_disparar = NO;
	miobjetivo = entidad->ia->nodoObjetivo;
	mimapa = entidad->sprite->numMapa;
	miestado = entidad->ia->estado;
	mientidadobjetivo = entidad->ia->entidadObjetivo;

	//Comportamiento / decisiones
	/*switch (estado){
		case HUIR:
			
			break;
		case PERSEGUIR: //Ya se ha definido el nodo al que ir
			//Si he llegado al objetivo paso a atacar
			break;
		case ATACAR:
			if ()
			break;
		case NADA:

	}*/
	if (miestado != HUIR){

		if (numEntidadesMapa(mimapa) > entidad->ia->maxCerca+1){
			//huir
			//debug_dummy();
			switch(mimapa){
				case 0:
					miobjetivo = 2;
					break;
				case 1:
					miobjetivo = 0;
					break;
				case 2:
					miobjetivo = 1;
					break;
				case 8:
					miobjetivo = 18;
					break;
				case 9:
					miobjetivo = 19;
					break;
				case 10:
					miobjetivo = 17;
					break;
			}
			miestado = HUIR;
		}
		/*else if(miestado == ESPERA){
			if (numEntidadesMapa(mimapa) == 1){
				switch(mimapa){
					case 0:
						miobjetivo = 15;
						break;
					case 1:
						miobjetivo = 16;
						break;
					case 2:
						miobjetivo = 12;
						break;
					case 8:
						miobjetivo = 13;
						break;
					case 9:
						miobjetivo = 1;
						break;
					case 10:
						miobjetivo = 0;
						break;
				}
			}
			else{
				mientidadobjetivo = numEntidadCerca(entidad);
				miestado = PERSEGUIR;
			}
		}*/
		/*if (miestado == PERSEGUIR){
			if (mientidadobjetivo < 8) miobjetivo = enemigo[mientidadobjetivo].nodo;
			else miobjetivo = player.nodo;
		}*/
	}
	/*else{
		if (miobjetivo == minodo) miestado = ESPERA;
	}*/



	if(miobjetivo != minodo){	//No estamos donde queremos estar
		/*if (entidad->ia->nodoSiguiente == entidad->nodo){	//Hemos llegado al nodo siguiente
			entidad->ia->nodoSiguiente = listaNodos[entidad->nodo].tabla[entidad->ia->nodoObjetivo];
		}*/

		//entidad->ia->nodoSiguiente = listaNodos[minodo].tabla[entidad->ia->nodoObjetivo];
		misiguiente = listaNodos[minodo].tabla[miobjetivo];
		entidad->ia->nodoSiguiente = misiguiente;

		//movernos
		if (listaNodos[misiguiente].mapa + 8 == entidad->sprite->numMapa ||
			(entidad->sprite->y[0] > listaNodos[misiguiente].y &&
			abs(entidad->sprite->y[0],listaNodos[misiguiente].y) > MARGEN_NODOS_Y &&
			listaNodos[misiguiente].mapa == entidad->sprite->numMapa)){		//Evaluar si esta encima para saltar
			entidad->ia->d_salto = SI;
		}
		if (listaNodos[misiguiente].mapa +1 == entidad->sprite->numMapa ||
			entidad->sprite->x[0] > listaNodos[misiguiente].x &&
			entidad->sprite->numMapa == listaNodos[misiguiente].mapa ||
			entidad->sprite->x[0] > listaNodos[misiguiente].x &&
			abs(listaNodos[misiguiente].mapa,entidad->sprite->numMapa) == 8){
			entidad->ia->d_direccion = IZQUIERDA;
			//d42 = 1;
			//cpct_setBorder(HW_BLUE);
		}
		else if (listaNodos[misiguiente].mapa == entidad->sprite->numMapa + 1 ||
			entidad->sprite->x[0] < listaNodos[misiguiente].x &&
			entidad->sprite->numMapa == listaNodos[misiguiente].mapa ||
			entidad->sprite->x[0] < listaNodos[misiguiente].x &&
			abs(listaNodos[misiguiente].mapa,entidad->sprite->numMapa) == 8){
			entidad->ia->d_direccion = DERECHA;
			//d42 = 2;
			//cpct_setBorder(HW_RED);
		}
			//Evaluar si esta a la derecha o izquierda para moverse en esa direccion
	}
	else{
		/*if (miestado == PERSEGUIR){
			miestado = ATACAR;
		}
		if (miestado == ATACAR){
			if (mientidadobjetivo < 8){
				if (enemigo[mientidadobjetivo].sprite->x[0] > entidad->sprite->x[0]){
					entidad->ia->d_direccion = DERECHA;
				}else{
					entidad->ia->d_direccion = IZQUIERDA;
				}
				entidad->ia->d_disparar = SI;
			} else{
				if (player.sprite->x[0] > entidad->sprite->x[0]){
					entidad->ia->d_direccion = DERECHA;
				}else{
					entidad->ia->d_direccion = IZQUIERDA;
				}
				entidad->ia->d_disparar = SI;
			}
		}*/
		if (miestado == HUIR){
			miestado = ESPERA;
		}
	}
	entidad->ia->nodoObjetivo = miobjetivo;
	entidad->ia->estado = miestado;
}

void CalcularNodoPlayer(){
	u8 i = 0;
	u8 distaux = 0;
	while (i < NUM_NODOS){
		distaux = distanciaEN(&player,i);
		//if (dist > distaux){
		if (distaux < MARGEN_NODOS_X){
			//if (listaNodos[entidad->nodo].cercanos[i] < 30) entidad->nodo = listaNodos[entidad->nodo].cercanos[i];
			player.nodo = i;
			//dist = distaux;
		}
		++i;
	}
}


/*
  _____       _      _       
 |_   _|     (_)    (_)      
   | |  _ __  _  ___ _  ___  
   | | | '_ \| |/ __| |/ _ \ 
  _| |_| | | | | (__| | (_) |
 |_____|_| |_|_|\___|_|\___/ 
                             
*/



void inicializar()
{
	cpct_disableFirmware();
	cpct_setVideoMode(0);
	cpct_memset((u8*)0x8000, 0, 0x4000); // Para doble buff
	cpct_setBorder(HW_BLACK);
	cpct_setPalette(g_palette, 16);
	//cpct_akp_musicInit(g_introsong);


	//menu = 1;
	empiezaJuego = NO;
	gameover = NO;

	/////////////////////////////////////// Sprites

	spriteJugador.imagen       = IMG_JUG_DER_QUIETO;
	spriteJugador.rol          = PLAYER;
	spriteJugador.x[0]         = 37*2;
	spriteJugador.y[0]         = 176;//15*8;
	spriteJugador.x[1]         = spriteJugador.x[0];
	spriteJugador.y[1]         = spriteJugador.y[0];
	spriteJugador.numMapa      = 16;
	spriteJugador.mapa         = casa;
	spriteJugador.direccion    = DERECHA;
	spriteJugador.ancho        = PLAYER_W;
	spriteJugador.alto         = PLAYER_H;
	spriteJugador.anchoBloques = 2;
	spriteJugador.altoBloques  = 3;
	spriteJugador.enAire       = NO;
//	spriteJugador.mover        = NO;

	spriteEnemigo[0].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[0].rol          = ENEMIGO;
	spriteEnemigo[0].x[0]         = 10;
	spriteEnemigo[0].y[0]         = 100;
	spriteEnemigo[0].x[1]         = spriteEnemigo[0].x[0];
	spriteEnemigo[0].y[1]         = spriteEnemigo[0].y[0];
	spriteEnemigo[0].numMapa      = 0;
	spriteEnemigo[0].mapa         = map11;
	spriteEnemigo[0].direccion    = DERECHA;
	spriteEnemigo[0].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[0].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[0].anchoBloques = 2;
	spriteEnemigo[0].altoBloques  = 3;
	spriteEnemigo[0].enAire       = NO;
//	spriteEnemigo[0].mover        = NO;

	spriteEnemigo[1].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[1].rol          = ENEMIGO;
	spriteEnemigo[1].x[0]         = 70;
	spriteEnemigo[1].y[0]         = 10;
	spriteEnemigo[1].x[1]         = spriteEnemigo[1].x[0];
	spriteEnemigo[1].y[1]         = spriteEnemigo[1].y[0];
	spriteEnemigo[1].numMapa      = 2;
	spriteEnemigo[1].mapa         = map31;
	spriteEnemigo[1].direccion    = DERECHA;
	spriteEnemigo[1].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[1].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[1].anchoBloques = 2;
	spriteEnemigo[1].altoBloques  = 3;
	spriteEnemigo[1].enAire       = NO;

	spriteEnemigo[2].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[2].rol          = ENEMIGO;
	spriteEnemigo[2].x[0]         = 28;
	spriteEnemigo[2].y[0]         = 96;
	spriteEnemigo[2].x[1]         = spriteEnemigo[2].x[0];
	spriteEnemigo[2].y[1]         = spriteEnemigo[2].y[0];
	spriteEnemigo[2].numMapa      = 8;
	spriteEnemigo[2].mapa         = map12;
	spriteEnemigo[2].direccion    = DERECHA;
	spriteEnemigo[2].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[2].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[2].anchoBloques = 2;
	spriteEnemigo[2].altoBloques  = 3;
	spriteEnemigo[2].enAire       = NO;

	spriteEnemigo[3].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[3].rol          = ENEMIGO;
	spriteEnemigo[3].x[0]         = 64;
	spriteEnemigo[3].y[0]         = 176;
	spriteEnemigo[3].x[1]         = spriteEnemigo[3].x[0];
	spriteEnemigo[3].y[1]         = spriteEnemigo[3].y[0];
	spriteEnemigo[3].numMapa      = 8;
	spriteEnemigo[3].mapa         = map31;
	spriteEnemigo[3].direccion    = DERECHA;
	spriteEnemigo[3].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[3].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[3].anchoBloques = 2;
	spriteEnemigo[3].altoBloques  = 3;
	spriteEnemigo[3].enAire       = NO;

	spriteEnemigo[4].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[4].rol          = ENEMIGO;
	spriteEnemigo[4].x[0]         = 40;
	spriteEnemigo[4].y[0]         = 176;
	spriteEnemigo[4].x[1]         = spriteEnemigo[4].x[0];
	spriteEnemigo[4].y[1]         = spriteEnemigo[4].y[0];
	spriteEnemigo[4].numMapa      = 9;
	spriteEnemigo[4].mapa         = map22;
	spriteEnemigo[4].direccion    = DERECHA;
	spriteEnemigo[4].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[4].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[4].anchoBloques = 2;
	spriteEnemigo[4].altoBloques  = 3;
	spriteEnemigo[4].enAire       = NO;

	spriteEnemigo[5].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[5].rol          = ENEMIGO;
	spriteEnemigo[5].x[0]         = 16;
	spriteEnemigo[5].y[0]         = 176;
	spriteEnemigo[5].x[1]         = spriteEnemigo[5].x[0];
	spriteEnemigo[5].y[1]         = spriteEnemigo[5].y[0];
	spriteEnemigo[5].numMapa      = 10;
	spriteEnemigo[5].mapa         = map32;
	spriteEnemigo[5].direccion    = DERECHA;
	spriteEnemigo[5].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[5].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[5].anchoBloques = 2;
	spriteEnemigo[5].altoBloques  = 3;
	spriteEnemigo[5].enAire       = NO;

	spriteEnemigo[6].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[6].rol          = ENEMIGO;
	spriteEnemigo[6].x[0]         = 64;
	spriteEnemigo[6].y[0]         = 56;
	spriteEnemigo[6].x[1]         = spriteEnemigo[6].x[0];
	spriteEnemigo[6].y[1]         = spriteEnemigo[6].y[0];
	spriteEnemigo[6].numMapa      = 10;
	spriteEnemigo[6].mapa         = map32;
	spriteEnemigo[6].direccion    = DERECHA;
	spriteEnemigo[6].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[6].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[6].anchoBloques = 2;
	spriteEnemigo[6].altoBloques  = 3;
	spriteEnemigo[6].enAire       = NO;
/*
	spriteEnemigo[7].imagen       = IMG_ENE_DER_QUIETO; //IMAGEN_ENEMIGO
	spriteEnemigo[7].rol          = ENEMIGO;
	spriteEnemigo[7].x[0]         = 70;
	spriteEnemigo[7].y[0]         = 10;
	spriteEnemigo[7].x[1]         = spriteEnemigo[7].x[0];
	spriteEnemigo[7].y[1]         = spriteEnemigo[7].y[0];
	spriteEnemigo[7].numMapa      = 2;
	spriteEnemigo[7].mapa         = map31;
	spriteEnemigo[7].direccion    = DERECHA;
	spriteEnemigo[7].ancho        = PLAYER_W; //ANCHO_ENEMIGO
	spriteEnemigo[7].alto         = PLAYER_H; //ALTO_ENEMIGO
	spriteEnemigo[7].anchoBloques = 2;
	spriteEnemigo[7].altoBloques  = 3;
	spriteEnemigo[7].enAire       = NO;
//	spriteEnemigo[1].mover        = NO;*/

	spriteBala[0].imagen          = IMAGEN_BALA;
	spriteBala[0].rol             = BALA;
	spriteBala[0].x[0]            = 0;
	spriteBala[0].y[0]            = 0;
	spriteBala[0].x[1]            = spriteBala[0].x[0];
	spriteBala[0].y[1]            = spriteBala[0].y[0];
	spriteBala[0].numMapa         = spriteJugador.numMapa;
	spriteBala[0].mapa            = spriteJugador.mapa;
	spriteBala[0].direccion       = DERECHA;
	spriteBala[0].ancho           = ANCHO_BALA;
	spriteBala[0].alto            = ALTO_BALA;
	spriteBala[0].anchoBloques    = 1;
	spriteBala[0].altoBloques     = 1;
	spriteBala[0].enAire          = NO;
//	spriteBala[0].mover           = NO;

	//IAs

	iaenemigo[0].nodoObjetivo = 17;		//Paramtetros de personalidad (valentia etc...)
	iaenemigo[0].nodoSiguiente;			// u8 nodoObjetivo;
	iaenemigo[0].d_direccion;			// u8 nodoSiguiente;
	iaenemigo[0].d_salto;				// u8 maxCerca;
	iaenemigo[0].d_disparar;			// u8 estado;
	iaenemigo[0].maxCerca = 0;			// u8 entidadObjetivo;
	iaenemigo[0].estado = ESPERA;
	iaenemigo[0].entidadObjetivo;

	iaenemigo[1].nodoObjetivo = 19;
	iaenemigo[1].nodoSiguiente;
	iaenemigo[1].d_direccion;
	iaenemigo[1].d_salto;		
	iaenemigo[1].d_disparar;
	iaenemigo[1].maxCerca = 0;
	iaenemigo[1].estado = ESPERA;
	iaenemigo[1].entidadObjetivo;

	iaenemigo[2].nodoObjetivo = 5;
	iaenemigo[2].nodoSiguiente;
	iaenemigo[2].d_direccion;
	iaenemigo[2].d_salto;		
	iaenemigo[2].d_disparar;
	iaenemigo[2].maxCerca = 0;
	iaenemigo[2].estado = ESPERA;
	iaenemigo[2].entidadObjetivo;

	iaenemigo[3].nodoObjetivo = 1;
	iaenemigo[3].nodoSiguiente;
	iaenemigo[3].d_direccion;
	iaenemigo[3].d_salto;		
	iaenemigo[3].d_disparar;
	iaenemigo[3].maxCerca = 0;
	iaenemigo[3].estado = ESPERA;
	iaenemigo[3].entidadObjetivo;

	iaenemigo[4].nodoObjetivo = 0;
	iaenemigo[4].nodoSiguiente;
	iaenemigo[4].d_direccion;
	iaenemigo[4].d_salto;		
	iaenemigo[4].d_disparar;
	iaenemigo[4].maxCerca = 0;
	iaenemigo[4].estado = ESPERA;
	iaenemigo[4].entidadObjetivo;

	iaenemigo[5].nodoObjetivo = 2;
	iaenemigo[5].nodoSiguiente;
	iaenemigo[5].d_direccion;
	iaenemigo[5].d_salto;		
	iaenemigo[5].d_disparar;
	iaenemigo[5].maxCerca = 0;
	iaenemigo[5].estado = ESPERA;
	iaenemigo[5].entidadObjetivo;

	iaenemigo[6].nodoObjetivo = 7;
	iaenemigo[6].nodoSiguiente;
	iaenemigo[6].d_direccion;
	iaenemigo[6].d_salto;		
	iaenemigo[6].d_disparar;
	iaenemigo[6].maxCerca = 0;
	iaenemigo[6].estado = ESPERA;
	iaenemigo[6].entidadObjetivo;
	

	/////////////////////////////////// Entidades

	player.estado        = QUIETO;
	player.id            = 8;
	player.bala          = &spriteBala[0];
	player.sprite        = &spriteJugador;

	enemigo[0].estado = ANDANDO;
	enemigo[0].id     = 0;
	enemigo[0].bala   = &spriteBala[1];
	enemigo[0].sprite = &spriteEnemigo[0];
	enemigo[0].nodo   = 17;
	enemigo[0].ia     = &iaenemigo[0];

	enemigo[1].estado = ANDANDO;
	enemigo[1].id     = 1;
	enemigo[1].bala   = &spriteBala[2];
	enemigo[1].sprite = &spriteEnemigo[1];
	enemigo[1].nodo   = 19;
	enemigo[1].ia     = &iaenemigo[1];

	enemigo[2].estado = ANDANDO;
	enemigo[2].id     = 1;
	enemigo[2].bala   = &spriteBala[3];
	enemigo[2].sprite = &spriteEnemigo[2];
	enemigo[2].nodo   = 5;
	enemigo[2].ia     = &iaenemigo[2];

	enemigo[3].estado = ANDANDO;
	enemigo[3].id     = 1;
	enemigo[3].bala   = &spriteBala[4];
	enemigo[3].sprite = &spriteEnemigo[3];
	enemigo[3].nodo   = 1;
	enemigo[3].ia     = &iaenemigo[3];

	enemigo[4].estado = ANDANDO;
	enemigo[4].id     = 1;
	enemigo[4].bala   = &spriteBala[5];
	enemigo[4].sprite = &spriteEnemigo[4];
	enemigo[4].nodo   = 0;
	enemigo[4].ia     = &iaenemigo[4];

	enemigo[5].estado = ANDANDO;
	enemigo[5].id     = 1;
	enemigo[5].bala   = &spriteBala[6];
	enemigo[5].sprite = &spriteEnemigo[5];
	enemigo[5].nodo   = 2;
	enemigo[5].ia     = &iaenemigo[5];

	enemigo[6].estado = ANDANDO;
	enemigo[6].id     = 1;
	enemigo[6].bala   = &spriteBala[7];
	enemigo[6].sprite = &spriteEnemigo[6];
	enemigo[6].nodo   = 7;
	enemigo[6].ia     = &iaenemigo[6];
}
/*
	u8 x,y;
	u8 mapa;
	u8 tabla[NUM_NODOS];
	u8 cercanos[MAX_NODOS_CERCANOS];
*/
void dummy_nodos() __naked{
	__asm
	_listaNodos::

	.db 40, 176
	.db 9
	.db 0,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1
	.db 1,2,99,99

	.db 64, 176
	.db 8
	.db 0,1,0,3,0,3,0,3,0,3,3,3,0,3,0,3,3,3,0,3
	.db 0,3,99,99

	.db 16,176
	.db 10
	.db 0,0,2,0,3,0,3,0,3,0,3,0,3,0,3,0,0,0,3,0
	.db 0,4,99,99

	.db 42,136
	.db 8
	.db 1,1,1,3,1,5,1,5,5,5,5,5,5,5,5,5,5,5,5,5
	.db 5,1,99,99

	.db 38,136
	.db 10
	.db 2,2,2,2,4,2,6,6,6,6,6,6,6,6,6,6,6,6,6,6
	.db 6,2,99,99

	.db 28,96
	.db 8
	.db 3,3,3,3,3,5,7,7,7,7,7,7,7,7,7,7,7,7,7,7
	.db 3,7,99,99

	.db 48, 96
	.db 10
	.db 4,4,4,4,4,8,6,8,8,8,8,8,8,8,8,8,8,8,8,8
	.db 4,8,99,99

	.db 64,56
	.db 8
	.db 9,3,9,3,9,5,9,7,9,9,9,11,9,11,11,11,11,11,11,11
	.db 11,9,5,3

	.db 16,56
	.db 10
	.db 10,10,4,10,4,10,6,10,8,10,10,10,12,12,12,12,12,12,12,12
	.db 12,10,6,4

	.db 24,56
	.db 9
	.db 0,0,2,7,0,7,20,7,20,9,20,7,20,7,20,17,20,7,20,7
	.db 7,20,0,99

	.db 56,56
	.db 9
	.db 0,0,0,0,8,20,8,20,8,20,10,20,8,20,8,20,8,20,8,8
	.db 8,20,0,99

	.db 40,16
	.db 8
	.db 7,7,7,7,7,7,7,7,7,7,7,11,13,13,13,13,13,13,13,13
	.db 13,7,99,99

	.db 40,16
	.db 10
	.db 8,8,8,8,8,8,8,8,8,8,8,14,12,14,14,14,14,14,14,14
	.db 14,8,99,99

	.db 64,176
	.db 0
	.db 11,11,11,11,11,11,15,11,15,11,11,11,15,13,15,15,15,17,15,15
	.db 17,15,11,99

	.db 16,176
	.db 2
	.db 12,12,12,12,12,16,12,16,12,12,12,16,12,16,14,16,16,16,18,16
	.db 18,16,12,99

	.db 16,176
	.db 1
	.db 13,13,16,13,16,13,16,13,16,13,13,13,16,13,16,15,16,13,16,19
	.db 19,16,13,99

	.db 64, 176
	.db 1
	.db 14,15,14,15,14,15,14,15,14,14,14,15,14,15,14,15,16,15,14,19
	.db 19,15,14,99

	.db 32,136
	.db 0
	.db 13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,17,13,13
	.db 13,99,99,99

	.db 48,136
	.db 2
	.db 14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,18,14
	.db 14,99,99,99

	.db 40, 136
	.db 1
	.db 15,15,16,15,16,15,16,15,16,15,16,15,16,15,16,15,16,15,16,19
	.db 15,16,99,99


	.db 40,8
	.db 9
	.db 0,9,10,9,10,9,10,9,10,9,10,9,10,9,10,9,10,9,10,9
	.db 9,10,0,99
	__endasm;
}
/*
void dummy_nodos() __naked{
	__asm
	_listaNodos::
	.db 40, 176
	.db 9
	.db
	__endasm;
}*/



/*void testSiguienteNodo(){
	cpct_scanKeyboard_if();
	/*if (cpct_isKeyPressed(Key_0)) 	   enemigo[0].ia->nodoObjetivo = 0;
	else if (cpct_isKeyPressed(Key_1)) enemigo[0].ia->nodoObjetivo = 1;
	else if (cpct_isKeyPressed(Key_2)) enemigo[0].ia->nodoObjetivo = 2;
	else if (cpct_isKeyPressed(Key_3)) enemigo[0].ia->nodoObjetivo = 3;
	else if (cpct_isKeyPressed(Key_4)) enemigo[0].ia->nodoObjetivo = 4;
	else if (cpct_isKeyPressed(Key_5)) enemigo[0].ia->nodoObjetivo = 5;
	else if (cpct_isKeyPressed(Key_6)) enemigo[0].ia->nodoObjetivo = 6;
	else if (cpct_isKeyPressed(Key_7)) enemigo[0].ia->nodoObjetivo = 7;
	else if (cpct_isKeyPressed(Key_8)) enemigo[0].ia->nodoObjetivo = 8;
	else if (cpct_isKeyPressed(Key_9)) enemigo[0].ia->nodoObjetivo = 9;
	else if (cpct_isKeyPressed(Key_Q)) enemigo[0].ia->nodoObjetivo = 10;
	else if (cpct_isKeyPressed(Key_W)) enemigo[0].ia->nodoObjetivo = 11;
	else if (cpct_isKeyPressed(Key_E)) enemigo[0].ia->nodoObjetivo = 12;
	else if (cpct_isKeyPressed(Key_R)) enemigo[0].ia->nodoObjetivo = 13;
	else if (cpct_isKeyPressed(Key_T)) enemigo[0].ia->nodoObjetivo = 14;
	else if (cpct_isKeyPressed(Key_Y)) enemigo[0].ia->nodoObjetivo = 15;
	else if (cpct_isKeyPressed(Key_U)) enemigo[0].ia->nodoObjetivo = 16;
	else if (cpct_isKeyPressed(Key_I)) enemigo[0].ia->nodoObjetivo = 17;
	else if (cpct_isKeyPressed(Key_O)) enemigo[0].ia->nodoObjetivo = 18;
	else if (cpct_isKeyPressed(Key_P)) enemigo[0].ia->nodoObjetivo = 19;
//	else if (cpct_isKeyPressed(Key_A)) enemigo[1].ia->nodoObjetivo = 0;
	else if (cpct_isKeyPressed(Key_L)) d11=d12=d21=d22=d31=d32=d41=d42=d43=d51=d52=d53=0;
}*/

/*
  __  __       _       
 |  \/  |     (_)      
 | \  / | __ _ _ _ __  
 | |\/| |/ _` | | '_ \ 
 | |  | | (_| | | | | |
 |_|  |_|\__,_|_|_| |_|

*/

void main(void)
{
	u8 i;
	cpct_setStackLocation((void*)0x8000); // Para doble buff
	inicializar();

	mapa.pintar = 2;//dibujarMapa();
	player.sprite->draw = 2;//dibujar(player.sprite);
	//dibujar(enemigo[0].sprite);
	//dibujar(enemigo[1].sprite);
	//Pruebas

	//enemigo[0].ia->nodoObjetivo = 9;
	//enemigo[1].ia->nodoObjetivo = 10;

	//u8 contador;
	contador = 0;
	while (1)
	{
		/*if (menu)
		{
			dibujarMenu();
			leerMenu();
			mapa.pintar = 2;
			//dibujarMapa(); // + enemigos del mapa
			//dibujar(player.sprite);
		}*/

		if (gameover==MAX_ENEMIGOS){
			player.sprite->numMapa=99;
			player.sprite->mapa=casa;
			player.sprite->x[0] = 37*2;
			player.sprite->y[0] = 7*8;

			mapa.pintar = 2;
			gameover=0;
			//dibujarMenu();
			//leerMenu();
		}
		// TESTING

		//testSiguienteNodo();
		//if (contador%5 == 0){
			/*if (d11 != enemigo[0].ia->estado/10 + 48){
				d11 = enemigo[0].ia->estado/10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(screen_mem, 0*2, 0*8),5,0,d11);
				cpct_drawCharM0(cpct_getScreenPtr(back_buffer, 0*2, 0*8),5,0,d11);
			}
			if (d12 != enemigo[0].ia->estado%10 + 48){
				d12 = enemigo[0].ia->estado%10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(screen_mem, 2*2, 0*8),5,0,d12);
				cpct_drawCharM0(cpct_getScreenPtr(back_buffer, 2*2, 0*8),5,0,d12);
			}
			if (d21 != enemigo[1].ia->estado/10 + 48){
				d21 = enemigo[1].ia->estado/10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(screen_mem, 5*2, 0*8),5,0,d21);
				cpct_drawCharM0(cpct_getScreenPtr(back_buffer, 5*2, 0*8),5,0,d21);
			}
			if (d22 != enemigo[1].ia->estado%10 + 48){
				d22 = enemigo[1].ia->estado%10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(screen_mem, 7*2, 0*8),5,0,d22);
				cpct_drawCharM0(cpct_getScreenPtr(back_buffer, 7*2, 0*8),5,0,d22);
			}
			/*if (d31 != enemigo[0].ia->nodoSiguiente/10 + 48){
				d31 = enemigo[0].ia->nodoSiguiente/10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 10*2, 0*8),5,0,d31);
			}
			if (d32 != enemigo[0].ia->nodoSiguiente%10 + 48){
				d32 = enemigo[0].ia->nodoSiguiente%10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 12*2, 0*8),5,0,d32);
			}

			if (d41 != enemigo[0].sprite->x/100 + 48){
				d41 = enemigo[0].sprite->x/100 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 15*2, 0*8),5,0,d41);
			}
			if (d42 != enemigo[0].sprite->x%100/10 + 48){
				d42 = enemigo[0].sprite->x%100/10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 17*2, 0*8),5,0,d42);
			}
			if (d43 != enemigo[0].sprite->x%100%10 + 48){
				d43 = enemigo[0].sprite->x%100%10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 19*2, 0*8),5,0,d43);
			}
			if (d51 != enemigo[0].sprite->y/100 + 48){
				d51 = enemigo[0].sprite->y/100 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 22*2, 0*8),5,0,d51);
			}
			if (d52 != enemigo[0].sprite->y%100/10 + 48){
				d52 = enemigo[0].sprite->y%100/10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 24*2, 0*8),5,0,d52);
			}
			if (d53 != enemigo[0].sprite->y%100%10 + 48){
				d53 = enemigo[0].sprite->y%100%10 + 48;
				cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 26*2, 0*8),5,0,d53);
			}
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 5*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 7*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 10*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 12*2, 0*8),5,0,8);

			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 15*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 17*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 19*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 22*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 24*2, 0*8),5,0,);
			cpct_drawCharM0(cpct_getScreenPtr(CPCT_VMEM_START, 26*2, 0*8),5,0,);*/
		//}

		if (contador%5 == 0){
			CalcularNodoPlayer();
			//enemigo[0].ia->nodoObjetivo = player.nodo;
			//enemigo[1].ia->nodoObjetivo = player.nodo +2;
		}
		++contador;
		

		// TESTING
		// Código de manejo de estados
		if (gameover<5) ejecutarEstado(&player);
		i = 0;
		while (i < MAX_ENEMIGOS && empiezaJuego == SI){
			if ((contador+i)%4 == 0 && enemigo[i].estado != MUERTO){
				CalcularIA(&enemigo[i]);
			}
			ejecutarEstado(&enemigo[i]);
			++i;
		}
		//moverBalas();


		// Código de dibujar en pantalla
		//cpct_akp_musicPlay();
		cpct_waitVSYNC();
		intercambiarBuffers(); // Para doble buff
		if (mapa.pintar) dibujarMapa();

		redibujar(player.bala);
		redibujar(player.sprite);

		for (i=0; i<MAX_ENEMIGOS; ++i)
			redibujar(enemigo[i].sprite);
	}
}


//////////////////////////////////////////////////////////////  NOTAS
//
//  MAPA GENÉRICO
//  =============
//
//  8 x 8 mapas = 64 mapas = 8000 bytes
//
//  [intro][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 0 al 7
//  [casa ][niv02][boss1][hist1][niv05][niv06][vacio][vacio] -> Niveles del 8 al 15
//  [vacio][niv03][niv04][niv09][niv08][niv07][boss2][niv10] -> Niveles del 16 al 23
//  [vacio][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 24 al 31
//  [vacio][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 32 al 39
//  [vacio][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 40 al 47
//  [vacio][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 48 al 55
//  [vacio][vacio][vacio][vacio][vacio][vacio][vacio][vacio] -> Niveles del 56 al 63
//
//
//  MAPA
//  ====
//  
//  2 bloques posibles:
//      0 -> Fondo
//      1 -> Bloque
//
//        4px   4px
//       _____ _____ _
//      |     |     |    NOTA: 4 y 8 pixeles para corregir la proporción del AMSTRAD
//   8px| (0) | (1) |
//      |_____|_____|_
//      |     |     |
//  
//  4px * 40 bloques = 160px (ANCHO)
//  8px * 25 bloques = 200px (ALTO)
//
//           40bl
//       _ _ _ _ _ _
//      |_|_|_|_|_|_      11111111 11111111 11111111 11111111 11111111-> 40bits -> 5 bytes
//      |_|_|_|_|_|_      10000000 00000000 00000000 00000000 00000001
//  25bl|_|_|_|_|_|_      10000000 00000000 00001111 00000000 00000001
//      |_|_|_|_|_|_      10000011 11111000 00000000 00000000 00000001
//      | | | | | |       10000011 11111000 00000000 00000000 00000001
//
//




//////////////////////////////////////////////////////////////  LICENCIA
//
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
